//---------------------------------------------------------------------------
#include <vcl.h>
#include <grids.hpp>
#pragma hdrstop

#include "SybSQL.h"  
#include "SybVariable.h"
#include "SybArray.h"
#include "SybaseDataBase.h"
#pragma resource "SQLEdit.dfm"
#pragma package(smart_init)
//---------------------------------------------------------------------------
// ValidCtrCheck is used to assure that the components created do not have
// any pure virtual functions.
//

static inline void ValidCtrCheck(TSybSQL *)
{
        new TSybSQL(NULL);
}

//---------------------------------------------------------------------------
// Dialog for entering SQL - should only be used at design time
//---------------------------------------------------------------------------
__fastcall TSQLEditit::TSQLEditit()
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TSQLEditit::ClearButtonClick(TObject *Sender)
{
SQLMemo->Lines->Clear();
}
//---------------------------------------------------------------------------
void __fastcall TSQLEditit::SaveButtonClick(TObject *Sender)
{
 ModalResult = mrOk;
}
//---------------------------------------------------------------------------
void __fastcall TSQLEditit::ExitButtonClick(TObject *Sender)
{
 ModalResult = mrCancel;
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
namespace Sybsql
{
        void __fastcall PACKAGE Register()
        {
                RegisterPropertyEditor( __typeinfo(TStringList), __classid(TSybSQL), "_SQL",
                __classid(TSQLProperty));
                RegisterPropertyEditor( __typeinfo(TString), __classid(TSybSQL), "_DatabaseObject",
                __classid(TSQLProperty));
                 TComponentClass classes[1] = {__classid(TSybSQL)};
                 RegisterComponents("SYBASE", classes, 0);
        }
}
//---------------------------------------------------------------------------
// Property Editor
//---------------------------------------------------------------------------

void __fastcall TSQLProperty::Initialize(void)
{
 ThisComponent = GetComponent(0);  // point to this component being edited  
 ptr = (TSybSQL*)ThisComponent;  // 'cast' the pointer
}

//---------------------------------------------------------------------------

 TPropertyAttributes __fastcall TSQLProperty::GetAttributes()
{
TPropertyAttributes pa;
  if(GetName()=="_DatabaseObject")
     (pa  << paAutoUpdate << paMultiSelect <<paValueList)  >> paRevertable;
  if(GetName()=="_SQL")
     (pa << paDialog  << paAutoUpdate << paMultiSelect )  >> paRevertable;
  return  pa;
}
//-------------------------------------------------------------------------

System::AnsiString __fastcall TSQLProperty::GetValue()
{
 if(GetName()=="_DatabaseObject") return ptr->DatabaseObject;
 if(GetName()=="_SQL")return "SQL";
 return "";
}
//-------------------------------------------------------------------------

void __fastcall TSQLProperty::GetValues(Classes::TGetStrProc Proc)
{
//int tot;
int i=0;
AnsiString TmpName;
TSybaseDatabase *ptr;
if(GetName()=="_DatabaseObject"){
  if(F1==0){
        MessageDlg("No TSybaseDataBase objects have been placed yet " \
         , mtInformation , TMsgDlgButtons() << mbOK , 0);
         Proc("None");
         return;
  }

  for(i=0;i<AllSybDatabases->Count;i++){
    ptr = (TSybaseDatabase*)AllSybDatabases->Items[i];
    TmpName = ptr->Owner->Name+"->"+ptr->Name;
    Proc(TmpName);
  }
}
if(GetName()=="_SQL")Proc("SQL");
}
//---------------------------------------------------------------------------

void __fastcall TSQLProperty::SetValue(const System::AnsiString Value)
{
 if(GetName()=="_DatabaseObject") ptr->DatabaseObject = Value;
}
//---------------------------------------------------------------------------

void __fastcall TSQLProperty::Edit()
{
int Result;
TSQLEditit *SQLEditit;

if(GetName()=="_SQL")
try{
  SQLEditit = new TSQLEditit();
  SQLEditit->SQLMemo->Lines->Assign(ptr->SQL);
  Result = SQLEditit->ShowModal();
  if(Result == mrOk)ptr->SQL->Assign(SQLEditit->SQLMemo->Lines);
  }
  __finally
  {delete  SQLEditit;}

}
/////////////////////////////////////////////////////////////////////////////
//---------------------------------------------------------------------------
// The main component
//---------------------------------------------------------------------------
/////////////////////////////////////////////////////////////////////////////
__fastcall TSybSQL::TSybSQL(TComponent* Owner)    // constructor
        : TComponent(Owner)
{
SQL = new TStringList();
ColObjects = new  TList();
ColData = new TList();
ColNums = new TList();
}
//---------------------------------------------------------------------------
__fastcall TSybSQL::~TSybSQL()               // destructor
{
if(SQL)delete SQL ;
if(ColObjects){ColObjects->Clear(); delete ColObjects;}
if(ColData){ColData->Clear();delete ColData;}
if(ColNums){ColNums->Clear();delete ColNums;}
}
//---------------------------------------------------------------------------
void __fastcall TSybSQL::SetExecute(bool Value)
{
  FExecute = Value;
  if(FExecute)Execute();
}
//---------------------------------------------------------------------------

void __fastcall TSybSQL::Execute()
{
AnsiString SQLString;
TSybaseDatabase* ptr;
int i,Result,row_now=0;
RETCODE RC;

// recover memory from any previous executes
if(ColObjects)ColObjects->Clear();
if(ColData)ColData->Clear();
if(ColNums)ColNums->Clear();
FGrid=false;

  if(F1==0){
        if(!FCancelMessages)
        MessageDlg("No TSybaseDataBase objects have been placed yet " \
         , mtInformation , TMsgDlgButtons() << mbOK , 0);
         FExecute=false;
         if(FOnMissingDBObject)FOnMissingDBObject(this);
         return;
  }
  dbproc = NULL;
  for(i=0;i<AllSybDatabases->Count;i++){
    ptr = (TSybaseDatabase*)AllSybDatabases->Items[i];
    if(ptr) if(ptr->Owner->Name+"->"+ptr->Name==DatabaseObject)break;
  }
  if(ptr) dbproc = ptr->dbproc;


  if(!dbproc){
        if(!FCancelMessages)
        MessageDlg("No running DB process found" \
         , mtInformation , TMsgDlgButtons() << mbOK , 0);
         FExecute=false;
         if(FOnDbNoProcess)FOnDbNoProcess(this);
         return;
  }

  dbcmd(dbproc,("set rowcount "+IntToStr(ptr->BufferSize)+" ").c_str());
  Result=0;  // now add the SQL
  //Tony
  for (i=0;i< SQL->Count;i++){
   SQLString = SQL->Strings[i] + " ";
   if( dbcmd(dbproc,SQLString.c_str())==FAIL)Result++;
  }
  if(Result){
        if(!FCancelMessages)
        MessageDlg("Error loading SQL" \
         , mtWarning , TMsgDlgButtons() << mbOK , 0);
         FExecute=false;
         if(FOnLoadSQLFail)FOnLoadSQLFail(this);
         return;
  }

  if(dbsqlexec(dbproc)==FAIL){
        if(!FCancelMessages)
        MessageDlg("Could not execute dbsqlexec with given SQL statements",\
        mtWarning , TMsgDlgButtons() << mbOK , 0);
        FExecute=false;
        if(FOnExecuteFail)FOnExecuteFail(this);
        return;
        }
  ColFound=0;
  _dbretstatus = 0;
  if(FOnBeforeQuery)FOnBeforeQuery(this);
  while ((RC = dbresults(dbproc))!=NO_MORE_RESULTS) {
    if ((RC == SUCCEED)&& (DBROWS(dbproc) == SUCCEED)) {
        column_count = dbnumcols(dbproc);
        // load the column data
        i=1;do{
          dbLocate(i);
        }while(i++ < column_count);
        ClearGrids();
        while (dbnextrow(dbproc)!= NO_MORE_ROWS){
          DoRows(row_now++);
        }
        /* Now check for a return status */
        if (dbhasretstat(dbproc) == TRUE)
        {
        _dbretstatus = dbretstatus(dbproc);
        }
   } //if
  } //while

  FExecute=false;
  if(FOnAfterQuery)FOnAfterQuery(this);
}
//---------------------------------------------------------------------------
 void __fastcall TSybSQL::DelColDetails(){

 }
//---------------------------------------------------------------------------

void _fastcall TSybSQL::SetCancelMessages(bool Value )
{
  FCancelMessages=Value;
}
//---------------------------------------------------------------------------

void _fastcall TSybSQL::DoRows(int row)
{
TLabel *LabelPtr=NULL;
TCustomEdit *EditPtr=NULL;
TComponent *ComponentPtr=NULL;
TCustomListBox *ListBPtr=NULL;
TCustomComboBox *ComboPtr=NULL;
TCustomMemo *MemoPtr=NULL;
TStringGrid *StringGridPtr=NULL;
TSybArray *ArrayPtr=NULL;  
TSybVariable *SybVar=NULL;
int i,start,*curcol;

// cycle through the list of objects linked to columns
// for each item in the list, add the corresponding data from the data list

          for(i=0;i< ColObjects->Count;i++){
            ComponentPtr = (TComponent*)ColObjects->Items[i];


            if(ComponentPtr->InheritsFrom(__classid(TLabel))){
              LabelPtr = (TLabel*)ComponentPtr;
              LabelPtr->Caption = StrPas((char*)ColData->Items[i]);
            }

            if(ComponentPtr->InheritsFrom(__classid(TEdit))){
              EditPtr = (TCustomEdit*)ComponentPtr;
              EditPtr->Text = StrPas((char*)ColData->Items[i]);
            }
            if(ComponentPtr->InheritsFrom(__classid(TCustomMemo))){
               MemoPtr = (TCustomMemo*)ComponentPtr;
               MemoPtr->Lines->Add(StrPas((char*)ColData->Items[i]));
            }

            if(ComponentPtr->InheritsFrom(__classid(TCustomListBox))){
               ListBPtr = (TCustomListBox*)ComponentPtr;
               ListBPtr->Items->Add(StrPas((char*)ColData->Items[i]));
            }

            if(ComponentPtr->InheritsFrom(__classid(TCustomComboBox))){
               ComboPtr = (TCustomComboBox*)ComponentPtr;
               ComboPtr->Items->Add(StrPas((char*)ColData->Items[i]));
            }

            if(ComponentPtr->InheritsFrom(__classid(TSybArray))){
               ArrayPtr = (TSybArray*)ComponentPtr;
               ArrayPtr->Array->Add(StrPas((char*)ColData->Items[i]));
            }
            
            if(ComponentPtr->InheritsFrom(__classid(TSybVariable))){
               SybVar = (TSybVariable*)ComponentPtr;
               SybVar->ColumnName = (char*)ColData->Items[i];
            }


            if(ComponentPtr->InheritsFrom(__classid(TStringGrid))){
               StringGridPtr = (TStringGrid*)ComponentPtr;
               start = StringGridPtr->FixedRows;
               if(row+start > StringGridPtr->RowCount)
                  StringGridPtr->RowCount = row+start;
               curcol = (int*)ColNums->Items[i];
               StringGridPtr->Cells[*curcol][start+row]= \
                 (AnsiString)((char*)ColData->Items[i]);
            }
        }// for
}
//---------------------------------------------------------------------------
void _fastcall TSybSQL::dbLocate( int column ){
char  *col_value=NULL;
AnsiString ColName, Data;
TComponent *F;
TComponent *ComponentPtr=NULL;
TLabel *LabelPtr=NULL;
TCustomEdit *EditPtr=NULL;
TCustomListBox *ListBPtr=NULL;
TCustomComboBox *ComboPtr=NULL;
TCustomMemo *MemoPtr=NULL;
TStringGrid *StringGridPtr=NULL;
TSybVariable *SybVar=NULL;
TSybArray *ArrayPtr=NULL;
int col_len,i,j,*colnum=NULL;

// for each column returned by Sybase, check if there is a corresponding component
// on the form.  If yes, then insert it's pointer in a list and create a char
// variable to bind to.

  ColName = dbcolname(dbproc, column);
  F= (TComponent*)Owner;
  ComponentPtr=F->FindComponent(ColName);
  col_len = dbcollen(dbproc,column);
  
if(ComponentPtr){

  if(ComponentPtr->InheritsFrom(__classid(TLabel))){
     LabelPtr = (TLabel*)ComponentPtr;
     ColObjects->Add(LabelPtr);
     col_value = new char[col_len];
     ColData->Add(col_value);
     colnum=new int();  //dummy place holder, used in string-grids
     ColNums->Add(colnum);
     dbbind(dbproc, column, STRINGBIND, (DBINT) 0, (unsigned char*)col_value);
     return;
     }
  if(ComponentPtr->InheritsFrom(__classid(TEdit))){
     EditPtr = (TCustomEdit*)ComponentPtr;
     ColObjects->Add(EditPtr);
     col_value = new char[col_len];
     ColData->Add(col_value);  
     colnum=new int();  //dummy place holder, used in string-grids
     ColNums->Add(colnum);   
     dbbind(dbproc, column, STRINGBIND, (DBINT) 0, (unsigned char*)col_value);
     return;
     }
  if(ComponentPtr->InheritsFrom(__classid(TCustomMemo))){
     MemoPtr = (TCustomMemo*)ComponentPtr;
     MemoPtr->Lines->Clear();
     ColObjects->Add(MemoPtr);
     col_value = new char[col_len];
     ColData->Add(col_value); 
     colnum=new int();  //dummy place holder, used in string-grids
     ColNums->Add(colnum); 
     dbbind(dbproc, column, STRINGBIND, (DBINT) 0, (unsigned char*)col_value);
     return;
     }
  if(ComponentPtr->InheritsFrom(__classid(TCustomListBox))){
     ListBPtr = (TCustomListBox*)ComponentPtr;
     ListBPtr->Items->Clear();
     ColObjects->Add(ListBPtr);
     col_value = new char[col_len];
     ColData->Add(col_value);  
     colnum=new int();  //dummy place holder, used in string-grids
     ColNums->Add(colnum);   
     dbbind(dbproc, column, STRINGBIND, (DBINT) 0, (unsigned char*)col_value);
     return;
     }
  if(ComponentPtr->InheritsFrom(__classid(TCustomComboBox))){
     ComboPtr = (TCustomComboBox*)ComponentPtr;
     ComboPtr->Items->Clear();
     ColObjects->Add(ComboPtr);
     col_value = new char[col_len];
     ColData->Add(col_value); 
     colnum=new int();  //dummy place holder, used in string-grids
     ColNums->Add(colnum);  
     dbbind(dbproc, column, STRINGBIND, (DBINT) 0, (unsigned char*)col_value);
     return;
     }
  if(ComponentPtr->InheritsFrom(__classid(TSybArray))){
     ArrayPtr = (TSybArray*)ComponentPtr;
     ArrayPtr->Array->Clear();
     ColObjects->Add(ArrayPtr);
     col_value = new char[col_len];
     ColData->Add(col_value);  
     colnum=new int();  //dummy place holder, used in string-grids
     ColNums->Add(colnum); 
     dbbind(dbproc, column, STRINGBIND, (DBINT) 0, (unsigned char*)col_value);
     return;
     }
  if(ComponentPtr->InheritsFrom(__classid(TSybVariable))){
     SybVar = (TSybVariable*)ComponentPtr;
     ColObjects->Add(SybVar);
     col_value = new char[col_len];
     ColData->Add(col_value); 
     colnum=new int();  //dummy place holder, used in string-grids
     ColNums->Add(colnum); 
     dbbind(dbproc, column, STRINGBIND, (DBINT) 0, (unsigned char*)col_value);
     return;
     }
  }
  else{
  // check for any string grids
  for (i=0;i< F->ComponentCount;i++){
     ComponentPtr = F->Components[i];
     if(ComponentPtr->InheritsFrom(__classid(TStringGrid))){
        StringGridPtr = (TStringGrid*)ComponentPtr;
        for(j=0;j< StringGridPtr->ColCount;j++ ){
          if(StringGridPtr->Cells[j][0]==ColName){
           // found one, now set the column width
           StringGridPtr->ColWidths[j] = \
             dbcollen(dbproc, column)* StringGridPtr->Font->Size*0.75;

           ColObjects->Add(StringGridPtr); // bind the object to the select-column
           col_value = new char[col_len];
           ColData->Add(col_value); // bind a data variable to the select-column

           colnum=new int();
           *colnum=j;   // j is the column within the string grid
           ColNums->Add(colnum);

           FGrid=true; 
           dbbind(dbproc, column, STRINGBIND, (DBINT) 0, (unsigned char*)col_value);
           return;
          }
        }
     }
  }
  } //else



}

//--------------------------------------------------------------------------- 
void _fastcall TSybSQL::ClearGrids(){
int i,k,l;
TComponent* ComponentPtr=NULL;
TStringGrid *StringGridPtr=NULL;

if(!FGrid)return;

  for(i=0;i< ColObjects->Count;i++){
     ComponentPtr = (TComponent*)ColObjects->Items[i];
     if(ComponentPtr->InheritsFrom(__classid(TStringGrid))){
        StringGridPtr = (TStringGrid*)ComponentPtr;
        for(k=StringGridPtr->FixedCols,l=StringGridPtr->FixedCols;\
               k<StringGridPtr->ColCount,l<StringGridPtr->RowCount;k++,l++)
               StringGridPtr->Cells[k][l]=""; // clear the grid
     }
  }
}
//---------------------------------------------------------------------------
